// This script gets you into the Spec/Unspec Temples using Hyssop (Malar).
//
// Change these settings to suit your character
var KeepFocus = true;         // Enables the Focus check..
var CheckTime = 1;            // time gap between checking if AC has focus (in minutes)

var Version    = "2005.04.08.2"
var PluginName = "SMIncFocus"
var PluginShortName = PluginName.slice(5)

macroDir = skapi.szDirAC + "\\SMIncScripts\\"

alertAdminWav	= skapi.WavNew(macroDir+"broadcast.wav");	// Played when admin detected
alertAlertWav	= skapi.WavNew(macroDir+"alert1.wav");  	// Played when stealth mode activated
alertDeathWav	= skapi.WavNew(macroDir+"dead.wav");		// Sound to play when we die

alertPlayerWav	= skapi.WavNew(macroDir+"fellow.wav");  	// Played when another player detected
alertPortalWav	= skapi.WavNew(macroDir+"portal.wav");		// Played when avoiding portal
alertTellWav	= skapi.WavNew(macroDir+"patron.wav");		// Played when @tell message detected
alertDingWav	= skapi.WavNew(macroDir+"vassal.wav");		// Played when other chat message detected
alertBeepWav	= skapi.WavNew(macroDir+"beep.wav");		

// Internal Variables, change at own risk

//raw
var h = new myHandlers();
var Go;
var opmAll = (opmDebugLog | opmChatWnd | opmConsole);
var Start;
var szSchema;
var First = true;

//main
var RunningClock;
var DebugFlag = false;
var DebugFlag2 = false;
var MinLastFocus = 0;
var AllGlobals = false;
var TurbineGlobals = true;

function MyHandlers_OnControlEvent(szPanel, szControl, dictSzValue)
{
	var BoolCheck;
	if (szPanel == PluginName)
	{
		switch (szControl)
		{
		case 'chkKeepFocus':
			KeepFocus = (dictSzValue('chkKeepFocus')=="True");
                        SmincAmber();
			skapi.OutputLine("Edited: Option - KeepFocus now " + dictSzValue('chkKeepFocus'), opmAll);
			break;
		case 'edtCheckTime':
			CheckTime = dictSzValue('edtCheckTime');
                        SmincAmber();
			skapi.OutputLine("Edited: Focus check - now every " + dictSzValue('edtCheckTime') + " minutes", opmAll);
			break;

		case 'chkTurbineGlobals':
			TurbineGlobals = (dictSzValue('chkTurbineGlobals')=="True");
                        SmincAmber();
			skapi.OutputLine("Edited: Option - Copying Turbine Globals to Console now " + dictSzValue('chkTurbineGlobals'), opmAll);
                        AllGlobals = false;
                        skapi.SetControlProperty(PluginName, "chkAllGlobals", "checked", "False")
			break;
		case 'chkAllGlobals':
			AllGlobals = (dictSzValue('chkAllGlobals')=="True");
                        SmincAmber();
			skapi.OutputLine("Edited: Option - Copying All Globals to Console now " + dictSzValue('chkAllGlobals'), opmAll);
                        TurbineGlobals = false;
                        skapi.SetControlProperty(PluginName, "chkTurbineGlobals", "checked", "False")
			break;

		case 'chkDebugFlag':
			DebugFlag = (dictSzValue('chkDebugFlag')=="True");
                        SmincAmber();
			skapi.OutputLine("Edited: Option - DebugFlag now " + dictSzValue('chkDebugFlag'), opmAll);
			break;
		case 'chkDebugFlag2':
			DebugFlag2 = (dictSzValue('chkDebugFlag2')=="True");
                        SmincAmber();
			skapi.OutputLine("Edited: Option - DebugFlag2 now " + dictSzValue('chkDebugFlag2'), opmAll);
			break;

		case 'btnQuit':
			Go = false;
			break;

		default:
			break;
		}			  	
	}
}

function MyHandlers_OnChatBoxMessage(szMsg, cmc)
{
	if (DebugFlag2) skapi.OutputLine("msg : " + szMsg + "cmc : " + cmc, opmChatWnd);

// Globals
        if ( cmc == 0 && ( (TurbineGlobals && (szMsg.indexOf("Turbine") > -1)) || AllGlobals ) ) {
            skapi.OutputLine(szMsg, opmConsole);
            alertTellWav.Play();
        }
}


function myHandlers()
{
 	this.OnControlEvent = MyHandlers_OnControlEvent;
 	this.OnChatBoxMessage = MyHandlers_OnChatBoxMessage;
}
 
function fAddHandlers()
{
 	skapi.AddHandler(evidOnControlEvent,h);
 	skapi.AddHandler(evidOnChatBoxMessage,h);
} 
 
function fRemoveHandlers()
{
 	skapi.RemoveHandler(evidOnControlEvent,h);
 	skapi.RemoveHandler(evidOnChatBoxMessage,h);
}

function GetFocus()
{
        if ( (Math.round(Start.cmsec/60000) - MinLastFocus) >= CheckTime ) {
            MinLastFocus = Math.round(Start.cmsec/60000);
            skapi.OutputLine(Math.round(Start.cmsec/60000) + " mins - Getting Focus" , opmConsole);

            if (DebugFlag) {
                SmincAmber();
                skapi.OutputLine(Math.round(Start.cmsec/60000) + " mins - Getting Focus", opmChatWnd,0);
            }
            skapi.ActivateAC()
        }
}

function SmincGreen()
{
//      yellow - green - yellow
 	skapi.OutputSz("<", opmChatWnd,4);
 	skapi.OutputSz(PluginShortName, opmChatWnd,0);
 	skapi.OutputSz("> ", opmChatWnd,4);
}

function SmincAmber()
{
//      orange - yellow - orange
 	skapi.OutputSz("<", opmChatWnd,22);
 	skapi.OutputSz(PluginShortName, opmChatWnd,4);
 	skapi.OutputSz("> ", opmChatWnd,22);
}

function SmincRed()
{
//      yellow - red - yellow
 	skapi.OutputSz("<", opmChatWnd,4);
 	skapi.OutputSz(PluginShortName, opmChatWnd,6);
 	skapi.OutputSz("> ", opmChatWnd,4);
}

function FmtNbr(nbr) { // Return a comma formatted string for a number
     var fstr="", str=nbr.toFixed(0), len= nbr<0 ? 4 : 3;
     while(str.length>len) {     // Is another comma needed?
          fstr= ","+str.slice(-3)+fstr;
          str= str.slice(0,-3);     // Remove the last 3 digits
     }
     return str+fstr;
} 

function FmtTime(Time) { // Return a comma formatted string for a number
     var Hours = Math.floor(Time/60);
     var Mins = Math.round(((Time/60)-Hours) * 60);
     return Hours + " Hours " + Mins + " Mins";
} 


function Initialise()
{
 	skapi.OutputLine(PluginName + "  v " + Version + " - Begin Macro" , opmAll,13);
 	skapi.OutputLine("Welcome " + skapi.szName , opmAll,13);

 	SetupSchema();
 	skapi.ShowControls(szSchema, First);
 	Go = true;

        RunningClock = Start.cmsec;

 	skapi.OutputLine("Date : " + Date(), opmAll,14);
 	skapi.OutputLine("Current Location : " + skapi.maplocCur.sz + "      Heading : " + Math.round(skapi.maplocCur.head) + " degrees", opmAll,14);
}

function main() 
{ 	
	var KeepRunning = true;
        Start = skapi.TimerNew();

	fAddHandlers();
	while (KeepRunning)
	{
		Initialise();
		while (Go)
		{
		var e;
		try {
                        if (DebugFlag2) {
                            skapi.OutputLine("Cycle  " + Math.round((Start.cmsec - RunningClock)/10)/100 + "  seconds" , opmChatWnd,5);
                            skapi.OutputLine("Running for  " + Math.round(Start.cmsec/60000*10)/10 + "  minutes" , opmChatWnd,5);
                            RunningClock = Start.cmsec;
                        }

			if ( Go && KeepFocus ) {
                            if (DebugFlag2) skapi.OutputLine("1 - Focus ", opmChatWnd,11);
                            GetFocus();
			}
                        skapi.WaitEvent(5000,3);

                    }
		catch (e)
                    {
			if (skapi.plig == pligNotRunning) {
                            Go = false;
			}
                    }
		}
		First = false;
 		skapi.RemoveControls(PluginName);
		KeepRunning = false;
 	}
 	fRemoveHandlers();
        SmincRed();
 	skapi.OutputLine(Math.round(Start.cmsec/60000) + " mins - " + PluginName + "  v " + Version + " - End Macro" , opmAll);
}
 
  function SetupSchema()
  {
  szSchema =
//  	"<view icon='10661' title='" + PluginName + "' \n" + 
  	"<view icon='10713' title='" + PluginName + "' \n" + 
  	"  width='180' height='205'>\n" + 
  	"  <control progid='DecalControls.FixedLayout'>\n" + 
  	"        <control name='edtSpacer' progid='DecalControls.Edit' text='' left='10' top='4' width='160' height='1' imageportalsrc='1291' />\n" +

  	"        <control name='chkKeepFocus' progid='DecalControls.CheckBox' fontstyle='bold' text='Check for Focus' left='10' top='10' width='150' height='20' checked='" + KeepFocus + "'/>\n" +
  	"        <control name='txtFocus' progid='DecalControls.StaticText' text='every' left='30' top='30' width='30' height='20' />\n" +
  	"        <control name='edtCheckTime' progid='DecalControls.Edit' text='" + CheckTime + "' left='60' top='30' width='18' height='16' imageportalsrc='1291' textcolor='8716155' />\n" +
  	"        <control name='txtFocus' progid='DecalControls.StaticText' text='minute(s).' left='83' top='30' width='50' height='20' />\n" +

  	"        <control name='edtSpacer' progid='DecalControls.Edit' text='' left='10' top='49' width='160' height='1' imageportalsrc='1291' />\n" +

  	"        <control name='txtGlobals' progid='DecalControls.StaticText' fontstyle='bold' text='Copy Globals to Console' left='10' top='55' width='150' height='20' />\n" +

  	"        <control name='chkTurbineGlobals' progid='DecalControls.CheckBox' text='Turbine globals' left='10' top='75' width='150' height='20' checked='" + TurbineGlobals + "' />\n" +
  	"        <control name='chkAllGlobals' progid='DecalControls.CheckBox' text='All globals' left='10' top='95' width='150' height='20' checked='" + AllGlobals + "' />\n" +

  	"        <control name='edtSpacer' progid='DecalControls.Edit' text='' left='10' top='114' width='160' height='1' imageportalsrc='1291' />\n" +

  	"        <control name='chkDebugFlag' progid='DecalControls.CheckBox' text='Debug' left='105' top='120' width='70' height='20' checked='" + DebugFlag + "' />\n" +
  	"        <control name='chkDebugFlag2' progid='DecalControls.CheckBox' text='' left='155' top='120' width='15' height='20' checked='" + DebugFlag2 + "' />\n" +
  	"        <control name='edtSpacer' progid='DecalControls.Edit' text='' left='10' top='139' width='160' height='1' imageportalsrc='1291' />\n" +

  	"        <control name='txtVer' progid='DecalControls.StaticText' text='v " + Version.slice(3,13) + "' left='10' top='153' width='70' height='20' textcolor='16777215' />\n" +

// colours : red : 255 	Green : 65280  Blue : 16711680 	Black : 0  White : 16777215  Magenta : 16711935  Cyan : 16776960  Yellow : 65535
// colours : Orange : 33023  Pale Yellow : 12648447  Deep Purple : 12583104  Dark Purple : 4194432  Teal : 13684808  Dark orange : 29414    Brown : 16512   Dark Brown : 12386

  	"      <control name='btnQuit'  progid='DecalControls.PushButton' text='Quit' left='105' top='148' width='65' height='20' />\n" + 
  	"  </control>\n" + 
 	"</view>";
}
